mod Ex09 logic: 'cl'

incl Mtex

incl Maux

loc rem 
  9. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 14.4.2005
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp
  konzultacie: stvrtok 13:00-14:00 miestnost I25

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane binarnym 
  vyhladavacim stromom. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex09*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Trees.  \end 

rem 
  \para \bf  Section. Binary Search Trees.  \end 

rem 
  \para \bf  Membership in binary search trees.  \end 

pred/2 Inbst 'Tex_p2_set_in'
  Inbst(x,t) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_inbst_inbt
    Bst(t) -> Inbst(x,t) <-> Inbt(x,t)
  \end

thm Spec_inbst_inbt
  Bst(t) -> Inbst(x,t) <-> Inbt(x,t)

rem 
  \para \bf  Insertion in binary search trees.  \end 

fun/2 Insert 'Tex_f2_set_insert'
  Insert(t,x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_insert_inbt
    Bst(t) -> Inbt(y,Insert(t,x)) <-> Inbt(y,t) \/ y = x
  \end
  \eq Spec_insert_bst
    Bst(t) -> Bst Insert(t,x)
  \end

thm Spec_insert_inbt
  Bst(t) -> Inbt(y,Insert(t,x)) <-> Inbt(y,t) \/ y = x

thm Spec_insert_bst
  Bst(t) -> Bst Insert(t,x)

rem 
  \para \bf  Maximal element in a binary search tree.  \end 

fun Max 
  Max(t) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_max_inbt
    Bst(t) & t != E -> Inbt(Max(t),t)
  \end
  \eq Spec_max_maximum
    Bst(t) & t != E & Inbt(x,t) -> x <= Max(t)
  \end

thm Spec_max_inbt
  Bst(t) & t != E -> Inbt(Max(t),t)

thm Spec_max_maximum
  Bst(t) & t != E & Inbt(x,t) -> x <= Max(t)

rem 
  \para \bf  Deletion of the maximal element in a binary search tree.  \end 

fun Delmax 
  Delmax(t) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_delmax_inbt
    Bst(t) & t != E -> Inbt(x,Delmax(t)) <-> Inbt(x,t) & x != Max(t)
  \end
  \eq Spec_delmax_bst
    Bst(t) & t != E -> Bst Delmax(t)
  \end

thm Spec_delmax_inbt
  Bst(t) & t != E -> Inbt(x,Delmax(t)) <-> Inbt(x,t) & x != Max(t)

thm Spec_delmax_bst
  Bst(t) & t != E -> Bst Delmax(t)

rem 
  \para \bf  Join of two binary search trees.  \end 

fun/2 Join 'Tex2_sqcup'
  Join(t1,t2) = t2 <- t1 = E
  Join(t1,t2) = Nd(Max(t1),Delmax(t1),t2) <- t1 != E

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_join_inbt
    Bst(t1) & Bst(t2) & Ltb(t1,t2) -> Inbt(x,Join(t1,t2)) <-> 
    Inbt(x,t1) \/ Inbt(x,t2)
  \end
  \eq Spec_join_bst
    Bst(t1) & Bst(t2) & Ltb(t1,t2) -> Bst Join(t1,t2)
  \end

thm Spec_join_inbt
  Bst(t1) & Bst(t2) & Ltb(t1,t2) -> Inbt(x,Join(t1,t2)) <-> 
  Inbt(x,t1) \/ Inbt(x,t2)

thm Spec_join_bst
  Bst(t1) & Bst(t2) & Ltb(t1,t2) -> Bst Join(t1,t2)

rem 
  \para \bf  Deletion in binary search trees.  \end 

fun/2 Delete 'Tex_f2_set_delete'
  Delete(t,x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_delete_inbt
    Bst(t) -> Inbt(y,Delete(t,x)) <-> Inbt(y,t) & y != x
  \end
  \eq Spec_delete_bst
    Bst(t) -> Bst Delete(t,x)
  \end

thm Spec_delete_inbt
  Bst(t) -> Inbt(y,Delete(t,x)) <-> Inbt(y,t) & y != x

thm Spec_delete_bst
  Bst(t) -> Bst Delete(t,x)

